% Euler-Maruyama: Asian option with Arithmetic Mean
clear all, close all, randn('state',13)
K = 1; r = 0.05; T = 1; N = 2^8; dt = T/N; M = 10000;   
mu = r; S_0 = 1; sigma_0 = 0.8;
S = S_0*ones(M,1); Sigma = sigma_0*ones(M,1); sumOfS = S;
for j = 1:N
    dW_1 = sqrt(dt)*randn(M,1); dW_2 = sqrt(dt)*randn(M,1); % independent of dW_1
    % To be safe!
    S = abs(S + dt*mu*S + sqrt(S).*Sigma.*dW_1);
    Sigma = abs(Sigma + dt*(sigma_0 - Sigma) + sqrt(Sigma).*dW_2);
    sumOfS = sumOfS + S;
end
meanOfX = sumOfS/(N+1); Price = exp(-r*T)*mean(max(0,meanOfX-K))
