function SPaths = AssetPaths_gBM(S0,mu,sigma,T,NSteps,NRepl)
% Calculates the asset paths using the exact formula
% NSteps = number of time steps to be taken
% NRepl  = number of paths to be simulated

dt = T/NSteps; mudt = (mu-0.5*sigma^2)*dt; sidt = sigma*sqrt(dt);
Increments = mudt + sidt*randn(NRepl, NSteps);
LogPaths = cumsum([log(S0)*ones(NRepl,1) , Increments] , 2);
SPaths = exp(LogPaths);
