function z = BoxMuller(u1, u2, join)
% join: joins the two normals into one.
% u1, u2 : are two (sequence of) uniform random numbers

if (nargin == 2)
	join = 1;
end
rho = sqrt ( -2 * log(u1) ); 
z1 = rho .* cos (2*pi*u2); z2 = rho .* sin (2*pi*u2);
if (join)
	z = [z1; z2];	
else
	z = [z1 z2];
end