% Euler-Maruyama
% dX = mu*X dt + sigma*sqrt(X) dW,   X_0 = 1
clear all, close all, randn('state',13)
T = 1; M = 2^8; dt = T/M; mu = 0.1; sigma = 0.5; X0 = 1;  
X = zeros(1,M+1); X(1) = X0;
for j = 1:M
    dW = sqrt(dt)*randn;
    a = mu*X(j); b = sigma*sqrt(X(j)); % calculate coefficients
    X(j+1) = X(j) + a*dt + b*dW;
end
plot([0:dt:T],X,'r-'), xlabel('t','FontSize',12), ylabel('X','FontSize',12)
print -r900 -deps '../figures/EM_sqrtAsset'
