function [price, lattice] = ...
    LatticeEurCall_PayLater(premium,S0,K,r,T,sigma,M)

dt = T/M; erdt = exp(r*dt); sqt = sqrt( exp(sigma^2*dt) - 1 );
u = erdt * (1 + sqt);
d = erdt * (1 - sqt); % or u=exp(sigma * sqrt(dt)); d=1/u;
q = 0.5;  % or q=(exp(r*dt) - d)/(u-d);
lattice = zeros(M+1,M+1);
for j=0:M
   if (S0*(u^j)*(d^(M-j)) > K)
      lattice(M+1,j+1)=S0*(u^j)*(d^(M-j)) - K - premium;
   end
end
for i=M-1:-1:0
   for j=0:i
      lattice(i+1,j+1) = exp(-r*dt) * ...
         (q * lattice(i+2,j+2) + (1-q) * lattice(i+2,j+1));
   end   
end
price = lattice(1,1);
