% Pay-Later Option Valuation by Binomial Lattice
clear all, close all

M = 25;
for i = 1:M
    [premium(i), value(i)] = fsolve(@(x) ...
        LatticeEurCall_PayLater(x,50,50,0.1,5/12,0.4,100*i), 10);
    payLater(i) = LatticeEurCall_PayLater...
                        (premium(i),50,50,0.1,5/12,0.4,100*M);
end
[ premium(end), value(end) ]

figure(1), plot(1:M, premium, '-o');
xlabel('M (x100)','FontSize',12), ylabel('Premium','FontSize',12)
print -r900 -deps '../figures/LatticeEurCall_PayLater_Ex_a' 
figure(2), plot(1:M, payLater, '-o'), hold on, plot(1:M, zeros(M),'r-.'),
xlabel('M (x100)','FontSize',12), ylabel('PayLater','FontSize',12)
print -r900 -deps '../figures/LatticeEurCall_PayLater_Ex_b' 
