% test MC_Call
clear all, close all, randn('state',13);
S0 = 10; K = 9; sigma = 0.1; r = 0.06; T = 1; M = 17;

for i = 1:M
    NRepl = 2^(i+4);
    [P, CI] = MonteCarlo_Call(S0,K,r,sigma,T,NRepl);
    Price(i) = P; confInterval(i,:) = CI;
end
format long; Price, confInterval
[C, Cdelta, P, Pdelta] = CallPut_Delta(S0,K,r,sigma,T);
plot([1:M], Price, 'o'), hold on
plot([0:M+1], ones(1,M+2)*C, 'r')
for i=1:M
    plot([i,i], confInterval(i,:), 'g--' )
end
xlabel('M (2^{M+4} Number of Samples)','FontSize',12), ylabel('V','FontSize',12)
print -r900 -deps '../figures/MC_Call_eg'