function [Price, CI] = MonteCarlo_Call(S0,K,r,sigma,T,NRepl)
% NRepl : number of replications (paths)

muT = (r - 0.5*sigma^2)*T; sigmaT = sigma * sqrt(T);
DiscPayoff = exp(-r*T) * max( 0, S0*exp(muT+sigmaT*randn(NRepl,1)) - K );
% Matlab command for the Mean and Standard Deviation and the Confidence Interval
%[Price, SDev, CI] = normfit(DiscPayoff);
Price = mean(DiscPayoff); width = 1.96*std(DiscPayoff)/sqrt(NRepl); 
CI = [Price-width, Price+width];