function z = MultivariateNormalRandom(mu, Sigma, howMany)
% generates multivariate normal variates with given mu (vector), Sigma (matrix)

n = length(mu); z = zeros(howMany, n); mu = mu(:); % column vector
L = chol(Sigma); % Cholesky factorization of Sigma
% Remark: in Matlab chol produces an upper triangular matrix
for i = 1:howMany
    z(i,:) = mu' + randn(1,n) * L;
end
