% At maturity the payoff from a call spread option is max(S1-S2-K,0)
% At maturity the payoff from a put spread option is max(K-S1+S2,0)
clear all, close all, randn('state', 13)

flag_CallPut = 'c'; S1 = 110; S2 = 100; K = 1; r = 0.06; sum=0;
mu1 = r; mu2 = r; sigma1 = .2; sigma2 = .3; rho = .5; T = 1; nPaths = 10000;
if flag_CallPut == 'c' 
    z = 1; %  Will return call option value
else
    z = -1;   % Will return put option value
end
drift1 = (mu1 - sigma1^2 / 2) * T; drift2 = (mu2 - sigma2^2 / 2) * T; 
sigma1Sqrdt = sigma1 * sqrt(T); sigma2Sqrdt = sigma2 * sqrt(T);
for i = 1:nPaths,
    Z1 = randn; Z2 = rho * Z1 + randn * sqrt(1 - rho ^ 2);
    St1 = S1 * exp(drift1 + sigma1Sqrdt * Z1);
    St2 = S2 * exp(drift2 + sigma2Sqrdt * Z2);        
    sum = sum + max(z * (St1 - St2 - K), 0); 
end
Price = exp(-r * T) * (sum / nPaths)