% WienerProcess Histogram (vectorised)
clear all, close all, randn('state',13)
T = 1; N = 300; dt = T/N; M = 10000; % number of paths
for i = 1:M
    dW = sqrt(dt)*randn(1,N); W = cumsum(dW);
    phi(i) = W(end);
end
histfit(phi, 50); 
xlabel('W(T)','FontSize',12), ylabel('M number of W(T) Values','FontSize',12)
print -r900 -depsc -cmyk '../figures/hist10000'
