function [standardDev, returnLevels, weights] = ...
    attainablePortfolios(expectedReturns, covarianceMatrix,nPoints)

n = length(expectedReturns);
% discretize the portfolio expected target returns 
lowest = min(expectedReturns); highest = max(expectedReturns);
step = (highest-lowest) / (nPoints-1); returnLevels = (lowest:step:highest)';
m=length(returnLevels); variances = zeros(1,m); weights = zeros(n,m);

% set up the quadratic programming
c = zeros(n,1); Aeq = [expectedReturns; ones(1,n)];
vlb = zeros(n,1); vub = ones(n,1); x0 = zeros(1,n);

for i = 1:m
    beq = [returnLevels(i,1);1];
	x = quadprog(covarianceMatrix, c, [], [], Aeq, beq, vlb, vub, x0);
	variances(i) = x' * covarianceMatrix * x; weights(:,i) = x;
end
standardDev = sqrt(variances);
