function [BondPrice, BondDuration, BondConvexity, Approx] = ...
    bondChar_Discrete(cashFlows, times, faceValue, yield, changeInYield)

% Insert faceValue into the cash flows.
cashFlows(end) = cashFlows(end) + faceValue;
% Calculate
discountFactor = 1.0/(1+yield);
BondPrice = sum( (discountFactor.^times) .* cashFlows );
BondDuration = discountFactor .* 1/BondPrice ...
    * sum( times .* (discountFactor.^times) .* cashFlows );
BondConvexity = discountFactor^2 .* 1/BondPrice ...
    * sum( times .* (times+1) .* (discountFactor.^times) .* cashFlows );
% Approximate bond price given the change in yield
Approx = BondPrice * (1 - BondDuration * changeInYield ...
             + 0.5 * BondConvexity * changeInYield^2 );
