clear all, close all
% bonds
settle = '01-Jan-2007';
maturity = ['10-Jan-2020'; '20-Oct-2018'; '30-Aug-2025'; ...
            '01-Mar-2020'; '21-Oct-2015'];
face = [300; 1000; 200; 100; 100];
couponRate = [0.08; 0.07; 0.06; 0.05; 0.05];
cleanPrice = [ 256.8205; 688.4300; 121.3829; 69.4931; 66.6912 ];
% for more information on 'cleanPrice' see 'bndprice', or compare
% yieldsExpected = [0.1, 0.12, 0.11, 0.09, 0.11];
% cleanPrice = bndprice(yieldsExpected, couponRate, ...
%    settle, maturity,[],[],[],[],[],[],[],face)

% yields, durations, convexities
yields = bndyield(cleanPrice, couponRate, settle, maturity, ...
           2, 0, [] , [] , [] , [], [] , face);
durations = bnddury(yields, couponRate, settle, maturity, ...
            2, 0, [] , [] , [] , [], [] , face);
convexities = bndconvy(yields, couponRate, settle, maturity, ...
              2, 0, [] , [] , [] , [], [] , face);
% coefficient matrix, and right-hand-side vector
A = [durations'; convexities'; ones(1,5)];
% b vector is near the average values of durations and convexities
b = [ 7.50 ; 80.50 ; 1]; % but the last row is 1!
[weights, maxYield] = maximumYield(yields, A, b)