% impliedVola
clear all, close all
K = [1.00 1.25 1.50 1.75 2.00 2.25 2.50 2.75 3.00];
Obs = [1.2098 1.0280 0.8677 0.7298 0.6132 0.5157 0.4349 0.3682 0.3134];
S = 2; r = 0.03; T = 5;
for i = 1:length(K)
    [implVola(i), value(i)] = fsolve(@(x) ...
        Obs(i) - CallPut_Delta(S, K(i), r, x, T), 0.3);
end
[implVola', value']
plot(K,implVola,'-o', S*ones(1,length(K)), implVola, 'r--'), hold on
text(S, 0.32, 'Current Asset Price');
xlabel('Strike Price','FontSize',12), ylabel('Implied Volatility','FontSize',12) 
print -r900 -deps '../figures/impliedVola'
