% testAttainablePortfolios
clear all, close all
expectedReturns = [1, 0.9]; covarianceMatrix = [0.1, -0.1; -0.1, 0.2];

[standardDevM, returnsM, weightsM] = ...
    frontcon(expectedReturns, covarianceMatrix,20);
[standardDev, returns, weights] = ...
    attainablePortfolios(expectedReturns, covarianceMatrix,50);

myWeights = [0.5, 0.5]; myReturn = myWeights * expectedReturns';
myStandardDev = sqrt(myWeights * covarianceMatrix * myWeights');
plot(standardDevM, returnsM, 'r', 'LineWidth',2), hold on
plot(standardDev, returns, 'gx-.'), plot(myStandardDev, myReturn, 'bo')
text(myStandardDev, myReturn, '  my Portfolio','Fontsize',12),
legend('using "frontcon"', 'attainablePortfolios'),
ylabel('Portfolio expected return','Fontsize',12)
xlabel('Portfolio standard deviation','Fontsize',12)
print -r900 -deps '../figures/testAttainablePortfolios'