% testBinomialApproxUD_Am
clear all, close all
S0 = 50; K = 50; r = 0.1; sigma = 0.4; T = 5/12; flag = 1; D = 0;
[BS_call, BS_put] = blsprice(S0,K,r,T,sigma, D); % calculates exact price

maxM = 100; 
for M = 1:maxM
    price_AmPut(M) = BinomialApproxUD_Am(S0,K,r,T,sigma, M, flag, D);
    price_EuCall(M) = BinomialApproxUD_Dividend(S0,K,r,T,sigma, M, 0, D);
    price_AmCall(M) = BinomialApproxUD_Am(S0,K,r,T,sigma, M, 0, D);
end
figure(1), plot(1:maxM, ones(1,maxM)*BS_call, 'r-'), hold on
plot(1:maxM, price_EuCall, 'b-.'); plot(1:maxM, price_AmCall, 'ko');
xlabel('M','FontSize',12), ylabel('V','FontSize',12);
legend('European call (Black-Scholes)','European call (Binomial)',...
    'American call (Binomial)'), hold off
print -r900 -deps '../figures/testBinomialApproxUD_Am_a'
figure(2), plot(1:maxM, ones(1,maxM)*BS_put, 'r-'), hold on;
plot(1:maxM, price_AmPut, 'b-.o');
xlabel('M','FontSize',12), ylabel('V','FontSize',12);
legend('European put (Black-Scholes)', 'American put (Binomial)');
print -r900 -deps '../figures/testBinomialApproxUD_Am_b'
