% testBinomialApproxUD_Am_Dividend
clear all, close all
S = [0:150]'; K = 50; r = 0.2; sigma = 0.5; T = 1; flag = 0; D = 0.2;
[BS_call, BS_put] = blsprice(S,K,r,T,sigma, D); % calculates BS price
[BS_call0, BS_put0] = blsprice(S,K,r,T,sigma, 0); % with no dividend

M = 100; i=1; dS = 2.5;
for S0 = S(1):dS:S(end)
    price0(i) = BinomialApproxUD_Am(S0,K,r,T,sigma, M, flag, D);
    price(i) = BinomialApproxUD_Am(S0,K,r,T,sigma, M, 1, D);
    i = i+1;
end
payoffCall = max(S-K, 0); payoffPut = max(K-S, 0);
figure(1), plot(S, BS_call, 'c-'), hold on, plot(S(1):dS:S(end),price0, 'rx'), 
xlabel('S','FontSize',12), ylabel('V','FontSize',12), 
legend('Eu (Black-Scholes)', 'Am (Binomial)', 'Location', 'NorthWest'),
plot(S, payoffCall, '-.'), hold off
print -r900 -deps '../figures/testBinomialApproxUD_Am_Dividend0'
figure(2), plot(S, BS_put, 'c-'), hold on, plot(S(1):dS:S(end),price, 'rx'), 
xlabel('S','FontSize',12), ylabel('V','FontSize',12), 
legend('Eu (Black-Scholes)', 'Am (Binomial)'),
plot(S, payoffPut, '-.'), hold off
print -r900 -deps '../figures/testBinomialApproxUD_Am_Dividend'