% testBinomialApproxUD_Dividend
clear all, close all
S = [0:150]'; K = 50; r = 0.2; sigma = 0.5; T = 1; flag = 0; D=0.2;
[BS_call, BS_put] = blsprice(S,K,r,T,sigma, D); % calculates BS price
[BS_call0, BS_put0] = blsprice(S,K,r,T,sigma, 0); % with no dividend

M = 100; i=1; dS = 5;
for S0 = S(1):dS:S(end)
    price0(i) = BinomialApproxUD_Dividend(S0,K,r,T,sigma, M, flag, 0);
    price(i) = BinomialApproxUD_Dividend(S0,K,r,T,sigma, M, flag, D);
    i = i+1;
end
payoffCall = max(S-K, 0); payoffPut = max(K-S, 0);
figure(1), plot(S, payoffCall, '-.'), hold on
plot(S, BS_call0, 'c-'), plot(S(1):dS:S(end),price0, 'rx'), 
xlabel('S','FontSize',12), ylabel('V','FontSize',12), hold off
print -r900 -deps '../figures/testBinomialApproxUD_Dividend0'
figure(2), plot(S, payoffCall, '-.'), hold on
plot(S, BS_call, 'c-'), plot(S(1):dS:S(end),price, 'rx'), 
xlabel('S','FontSize',12), ylabel('V','FontSize',12), hold off
print -r900 -deps '../figures/testBinomialApproxUD_Dividend'
