% testBinomialExactQ
clear all, close all
S0 = 50; K = 50; r = 0.1; sigma = 0.4; T = 5/12; flag = 0;
[BS_call, BS_put] = blsprice(S0,K,r,T,sigma); % calculates exact price

maxM = 100; 
for M = 1:maxM
    priceApprox(M) = BinomialApproxUD(S0,K,r,T,sigma, M, flag);
    price(M) = BinomialExactQ(S0,K,r,T,sigma, M, flag);
end
plot(1:maxM, ones(1,maxM)*BS_call, 'g-'), hold on;
plot(1:maxM, price, 'r-o'); xlabel('M','FontSize',12), ylabel('V','FontSize',12)
print -r900 -deps '../figures/testBinomialExactQ'
