% testHeatSolutions
clear all, close all, 
% exact Solution 
u = inline('exp(-pi^2*t)*sin(pi*x)', 'x', 't'); 
a = 0; b = 1; tmax = 0.5; dx = 0.1; dt = 0.0005; % dt = 0.01;

f = @heatInitialFunction; 
alpha = @heatLeftBoundary; beta = @heatRightBoundary;
 w = heatExplicit(f, alpha, beta, a, b, dx, dt, tmax);
% w = heatImplicit(f, alpha, beta, a, b, dx, dt, tmax);
% w = heatCrankNicolson(f, alpha, beta, a, b, dx, dt, tmax);

[m,n] = size(w); x = linspace(a,b,m); t = linspace(0,tmax,n);
w(3,end), u(0.2,0.5), lambda = dt/dx^2 % at x = 0.2, t = 0.5

figure(1), plot(x, u(x,tmax)), hold on % exact solution 
plot(x, w(:,end), 'rx'),   % approx 
xlabel('x','FontSize',12), ylabel('w(:,end)','FontSize',12), hold off
print -r900 -depsc -cmyk '../figures/testHeatExplicit_a'
figure(2), mesh(x,t,w'), xlabel('x','FontSize',12), ylabel('t','FontSize',12), 
zlabel('w(x,t)','FontSize',12), hold off
print -r300 -depsc -cmyk '../figures/testHeatExplicit_b'
