m = 1000; n = 5000; rand('state', 13);
A = rand(m,n); x = rand(n,1); y = zeros(m,1);
tic;
% usual way
for j = 1:n % loop over columns
    for i = 1:m % loop over rows
        y(i) = y(i) + A(i,j)*x(j); % multiplication rule for matrices
    end
end
toc; % disp(num2str(y)), tic;
tic;
% in general, may be slightly better: vectorised over columns
for i = 1:m
    y(i) = A(i,:) * x; % dot product
    % y(i) = dot( A(i,:), x ); % seems to be the worst (why?)
end
toc; % disp(num2str(y)), tic;
tic;
% best one
y = A*x; % Matlab's way of multiplication
toc; % disp(num2str(y))